# Soba

Soba is an experimental rack server, which build upon green thread.

Green thread can easily achieve high concurrent(especially for IO-heavy app), and save the costs of native threads.

Soba use [LightIO](https://github.com/socketry/lightio) to provision green threads. 

## Installation

Add this line to your application's Gemfile:

```ruby
gem 'soba'
```

And then execute:

    $ bundle

Or install it yourself as:

    $ gem install soba

## Usage

This is a example of soba with rack, put these content into `config.ru`, then run `rackup` to start soba.

Notice:
>  1. Even in rails, soba should be started through `rackup`, so we can apply monkey patch before other code loaded. 
>  2. In `config.ru`, the commented first line is rackup arguments.

``` ruby
#\ -s soba -O Port=3000

# apply green threads monkey patch before application load
require 'soba/monkey'
Soba::Monkey.patch!

use Rack::Reloader, 0
use Rack::ContentLength

app = proc do |env|
  [ 200, {'Content-Type' => 'text/plain'}, ["你好，世界"] ]
end

run app

```

See [examples](/examples/)

## Development

After checking out the repo, run `bin/setup` to install dependencies. Then, run `rake spec` to run the tests. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`, which will create a git tag for the version, push git commits and tags, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/[USERNAME]/soba. This project is intended to be a safe, welcoming space for collaboration, and contributors are expected to adhere to the [Contributor Covenant](http://contributor-covenant.org) code of conduct.

## License

The gem is available as open source under the terms of the [MIT License](https://opensource.org/licenses/MIT).

## Code of Conduct

Everyone interacting in the Soba project’s codebases, issue trackers, chat rooms and mailing lists is expected to follow the [code of conduct](https://github.com/[USERNAME]/soba/blob/master/CODE_OF_CONDUCT.md).
